import { Controller, Get, Inject } from '@midwayjs/decorator';
import { Context } from '@midwayjs/koa';
import { ApiResponse, ApiTags } from '@midwayjs/swagger';
// import { TokenService } from '../service/token.service';
const assert = require('assert');
import { JwtService } from '@midwayjs/jwt';
import get = require('lodash/get');
import { RoleService } from '../service/system/role.service';
@ApiTags(['工具'])
@Controller('/token')
export class TokenController {
  // @Inject()
  // service: TokenService;

  @Inject()
  jwtService: JwtService;

  @Inject()
  roleService: RoleService;

  @Inject()
  ctx: Context;

  @Get('/tokenView')
  @ApiResponse({})
  async tokenView() {
    const token = get(this.ctx, 'request.header.token');
    assert(token, '缺少token信息');
    const result: any = await this.jwtService.decode(token);
    const menus = await this.roleService.getUserMenus();
    result.menus = menus;
    return result;
  }

  // @Get('/app')
  // async appLogin(fiiter) {
  //   const { config, js_code } = fiiter.query;
  //   const result: any = await this.service.appLogin(config, js_code);
  //   return result;
  // }
}
