import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
// 处理三餐数据: 没有is_use就填上; 没有_id就填上
const mealDeal = (val: object) => {
  if (!val) return val;
  const obj: any = {};
  if (!('is_use' in val)) {
    obj.is_use = false;
  }
  if (!('_id' in val)) {
    obj._id = new ObjectId().toString();
  }
  const newObj = { ...obj, ...val };
  return newObj;
};

@modelOptions({
  schemaOptions: { collection: 'order' },
})
export class Order extends BaseModel {
  @prop({ required: false, index: false, zh: '微信用户' })
  openid: string;
  @prop({ required: false, index: false, zh: '日期' })
  date: string;
  @prop({ required: false, index: false, zh: '早餐', set: mealDeal })
  breakfast: object;
  @prop({ required: false, index: false, zh: '午餐', set: mealDeal })
  lunch: object;
  @prop({ required: false, index: false, zh: '晚餐', set: mealDeal })
  dinner: object;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
}
