import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'news' },
})
export class News extends BaseModel {
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: false, zh: '来源' })
  origin: string;
  @prop({ required: false, index: false, zh: '创建时间' })
  create_time: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: false, zh: '封面图片', remark: '1张' })
  img: Array<any>;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '类型', remark: '字典:健康咨询,国内新闻' })
  type: string;
  @prop({ required: false, index: false, zh: '是否使用', default: '0' })
  is_use: string;
}
