import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_arrange {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '日期' })
  'date': string = undefined;
  @ApiProperty({ description: '安排' })
  'arrange': object = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QDTO_arrange extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['date@start','date@end'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_arrange extends FVO_arrange {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_arrange {
  @ApiProperty({ description: '日期' })
  @Rule(RuleType['string']().empty(''))
  'date': string = undefined;
  @ApiProperty({ description: '安排' })
  @Rule(RuleType['object']().empty(''))
  'arrange': object = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_arrange extends FVO_arrange {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_arrange extends CDTO_arrange {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_arrange extends FVO_arrange {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
