import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_menu {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '参数列表' })
  'params': Array<any> = undefined;
  @ApiProperty({ description: '已点数量' })
  'order': number = undefined;
  @ApiProperty({ description: '图片' })
  'img': Array<any> = undefined;
  @ApiProperty({ description: '介绍' })
  'content': string = undefined;
  @ApiProperty({ description: '卡路里' })
  'reserve': number = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QDTO_menu extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
}

export class QVO_menu extends FVO_menu {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_menu {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '参数列表' })
  @Rule(RuleType['array']().empty(''))
  'params': Array<any> = undefined;
  @ApiProperty({ description: '已点数量' })
  @Rule(RuleType['number']().empty(''))
  'order': number = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'img': Array<any> = undefined;
  @ApiProperty({ description: '介绍' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '卡路里' })
  @Rule(RuleType['number']().empty(''))
  'reserve': number = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CVO_menu extends FVO_menu {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_menu extends CDTO_menu {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_menu extends FVO_menu {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
