import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_news {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '来源' })
  'origin': string = undefined;
  @ApiProperty({ description: '创建时间' })
  'create_time': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '封面图片' })
  'img': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_news extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['title'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
}

export class QVO_news extends FVO_news {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_news {
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '来源' })
  @Rule(RuleType['string']().empty(''))
  'origin': string = undefined;
  @ApiProperty({ description: '创建时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '封面图片' })
  @Rule(RuleType['array']().empty(''))
  'img': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_news extends FVO_news {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_news extends CDTO_news {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_news extends FVO_news {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
