import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { FrameworkErrorEnum, SearchBase, ServiceError } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_admin {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '是否是超级管理员' })
  'is_super': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': string = undefined;
  @ApiProperty({ description: 'openid' })
  'openid': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_admin extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['account'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
}

export class QVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_admin {
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().required().error(new ServiceError('缺少账号', FrameworkErrorEnum.NEED_BODY)))
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '是否是超级管理员' })
  @Rule(RuleType['string']().empty(''))
  'is_super': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['string']().empty(''))
  'role': string = undefined;
  @ApiProperty({ description: 'openid' })
  @Rule(RuleType['string']().empty(''))
  'openid': string = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_admin extends CDTO_admin {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
